diff -cNr ivtools-0.6.orig/src/IV-X11/kinput.c ivtools-0.6/src/IV-X11/kinput.c
*** ivtools-0.6.orig/src/IV-X11/kinput.c	Thu Jan  1 09:00:00 1970
--- ivtools-0.6/src/IV-X11/kinput.c	Wed Jan 28 20:32:12 1998
***************
*** 0 ****
--- 1,509 ----
+ /*
+  * Copyright (c) 1991, 1992 Fujitsu Oita Software Laboratory Limited
+  *
+  * Permission to use, copy, modify, and distribute this software and its
+  * documentation for any purpose is hereby granted without fee, provided
+  * that the above copyright notice and this permission notice appear in
+  * all copies of the software and related documentation, and the name of
+  * Fujitsu Oita Software Laboratory may not be used in any advertising or
+  * publicity relating to the software without specific, prior written
+  * prior permission of Fujitsu Oita Software Laboratory. 
+  * 
+  * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
+  * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
+  * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
+  *
+  * IN NO EVENT SHALL FUJITSU OITA SOFTWARE LABORATORY BE LIABLE FOR ANY
+  * SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR
+  * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
+  * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY
+  * OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
+  * PERFORMANCE OF THIS SOFTWARE.
+  *
+  * Author:  Toshihisa Eto, Fujitsu Oita Software Laboratory Limited, Japan
+  * 	E-Mail: eto@ai.cs.fujitsu.co.jp
+  * 	Nifty:	HBG02665
+  */
+ 
+ #ifdef JIV
+ 
+ #include <stdio.h>
+ 
+ #include <IV-X11/Xlib.h>
+ #include <IV-X11/xdisplay.h>
+ 
+ #include <IV-2_6/InterViews/world.h>
+ #include <InterViews/window.h>
+ #include <IV-X11/xwindow.h>
+ #include <InterViews/event.h>
+ #include <IV-X11/xevent.h>
+ 
+ #include <InterViews/kinput.h>
+ 
+ #define CONVBUFSIZE	1024
+ 
+ 
+ // following line's code is copy from kinput2/include/ConvProto.h
+ #define CONV_ATTR(code,len)	((unsigned long)((code)<<16)+(len))
+ 
+ #define UPPER16U(data)		(((data)>>16)&0xffff)
+ #define UPPER16S(data)		((short)(((data)>>16)&0xffff))
+ #define LOWER16U(data)		((data)&0xffff)
+ #define LOWER16S(data)		((short)((data)&0xffff))
+ 
+ #define CODE_OF_ATTR(head)	UPPER16U(head)
+ #define LENGTH_OF_ATTR(head)	LOWER16U(head)
+ 
+ #define CONVPROF_PROTOCOL_VERSION	1
+ 
+ /*
+  * Standard Conversion Attribute Codes (0-255)
+  */
+ 
+ /* 0-127: can be specified at any time (startup and during conversion) */
+ #define CONVATTR_NONE			0
+ #define CONVATTR_INDIRECT		1
+ #define CONVATTR_FOCUS_WINDOW		2
+ #define CONVATTR_SPOT_LOCATION		3
+ #define CONVATTR_CLIENT_AREA		4
+ #define CONVATTR_STATUS_AREA		5
+ #define CONVATTR_COLORMAP		6
+ #define CONVATTR_COLOR			7
+ #define CONVATTR_BACKGROUND_PIXMAP	8
+ #define CONVATTR_LINE_SPACING		9
+ #define CONVATTR_FONT_ATOMS		10
+ #define CONVATTR_CURSOR			11
+ 
+ /* 128-255: can be specified only at startup time */
+ #define CONVATTR_INPUT_STYLE		128
+ #define CONVATTR_EVENT_CAPTURE_METHOD	129
+ #define CONVATTR_USE_EXTENSION		255
+ 
+ /* argument for CONVATTR_INPUT_STYLE and CONVPROP_SUPPORTED_STYLES */
+ #define CONVARG_ROOTWINDOW		1L
+ #define CONVARG_OFFTHESPOT		2L
+ #define CONVARG_OVERTHESPOT		4L
+ 
+ /* argument for CONVATTR_EVENT_CAPTURE_METHOD */
+ #define CONVARG_NONE			0L
+ #define CONVARG_CREATE_INPUTONLY	1L
+ #define CONVARG_SELECT_FOCUS_WINDOW	2L
+ // to here
+ 
+ extern int	convCTtoEUC(unsigned char*, int, unsigned char*);
+ 
+ class ConvAtoms {
+   public:
+     ConvAtoms(XDisplay*);
+     ~ConvAtoms();
+ 
+     Atom	owner;		// _JAPANESE_CONVERSION
+     Atom	version;	// PROTOCOL-2.0
+     Atom	text;		// COMPOUND_TEXT
+     Atom	profile;	// _CONVERSION_PROFILE
+     Atom	type;		// _CONVERSION_ATTRIBUTE_TYPE
+     Atom	request;	// CONVERSION_REQUEST
+     Atom	notify;		// CONVERSION_NOTIFY
+     Atom	end;		// CONVERSION_END
+     Atom	endRequest;	// CONVERSION_END_REQUEST
+     Atom	attribute;	// CONVERSION_ATTRIBUTE
+     Atom	attrnotify;	// CONVERSION_ATTRIBUTE_NOTIFY
+ };
+ 
+ ConvAtoms::ConvAtoms(XDisplay* disp)
+ {
+     owner	= XInternAtom(disp, "JAPANESE_CONVERSION",	False);
+     version	= XInternAtom(disp, "PROTOCOL-2.0",		False);
+     text	= XInternAtom(disp, "COMPOUND_TEXT",		False);
+     profile	= XInternAtom(disp, "_CONVERSION_PROFILE",	False);
+     type	= XInternAtom(disp, "_CONVERSION_ATTRIBUTE_TYPE",False);
+     request	= XInternAtom(disp, "CONVERSION_REQUEST",	False);
+     notify	= XInternAtom(disp, "CONVERSION_NOTIFY",	False);
+     end		= XInternAtom(disp, "CONVERSION_END",		False);
+     endRequest	= XInternAtom(disp, "CONVERSION_END_REQUEST",	False);
+     attribute	= XInternAtom(disp, "CONVERSION_ATTRIBUTE",	False);
+     attrnotify	= XInternAtom(disp, "CONVERSION_ATTRIBUTE_NOTIFY", False);
+ }
+ 
+ ConvAtoms::~ConvAtoms()
+ {
+ }
+ 
+ class KinputRep {
+   public:
+     KinputRep(XWindow);
+     ~KinputRep();
+ 
+     static ConvAtoms*	convatoms;
+ 
+     // X Window properties
+     XDisplay*	display_;
+     XWindow	window;
+     XWindow	convowner;
+     Atom	property;
+     char	convertedString[CONVBUFSIZE];
+ 
+     boolean	isKinput2;
+     boolean	active;
+ 
+     // private method for communicate with kinput
+     boolean	CheckProtocols();
+     void	SendConversionRequest();
+     void	SendConversionEnd();
+     void	RecieveNotify(Event& ev);
+     boolean	RecieveText(Event& ev);
+ 
+     // public method for setting conversion style
+     void	SetInputStyle(long);
+     void	SetConversionSpot(int, int);
+ };
+ ConvAtoms*	KinputRep::convatoms;
+ 
+ // Kinput instance constructer
+ Kinput::Kinput(Window* win)
+ {
+     rep = new KinputRep(win->rep()->xwindow_);
+ }
+ 
+ Kinput::~Kinput()
+ {
+     delete rep;
+ }
+ 
+ // Conversion request to kinput
+ void Kinput::BeginConversion()
+ {
+     rep->SendConversionRequest();
+ }
+ 
+ void Kinput::BeginConversion(int x, int y)
+ {
+     rep->SendConversionRequest();
+ 
+     // Set conversion spot
+     rep->SetConversionSpot(x, y);
+ }
+ 
+ // Conversion end request to kinput
+ void Kinput::EndConversion()
+ {
+     rep->SendConversionEnd();
+ }
+ 
+ boolean Kinput::IsActive()
+ {
+     return rep->active;
+ }
+ 
+ // Event handling method
+ 
+ // Check event
+ boolean Kinput::IsKinputEvent(const Event& ev)
+ {
+     if ((ev.eventType == ClientEvent) ||
+ 	(ev.rep()->xevent_.type == ClientMessage)) {
+ 	// ClientMessage
+ 	XClientMessageEvent	*cev = &(ev.Rep()->xevent_.xclient);
+ 
+ 	if ((cev->window == rep->window) &&
+ 	    (cev->message_type == rep->convatoms->notify) &&
+ 	    (cev->data.l[0] == rep->convatoms->owner)) {
+ 
+ 	    // Catch Conversion Notify
+ 	    return true;
+ 	} else if ((cev->format == 32) &&
+ 		   (cev->message_type == rep->convatoms->end) &&
+ 		   (cev->data.l[0] == rep->convatoms->owner)) {
+ 
+ 	    // Catch End Notify
+ 	    return true;
+ 	}
+     } else if ((ev.eventType == PropertyEvent) ||
+ 	       (ev.rep()->xevent_.type == PropertyNotify)) {
+ 	// Catch Property Event
+ 	XPropertyEvent	*pev = &(ev.Rep()->xevent_.xproperty);
+ 
+ 	if ((rep->property != None)		&&
+ 	    (pev->window == rep->window)	&&
+ 	    (pev->atom == rep->property) 	&&
+ 	    (pev->state == PropertyNewValue)) {
+ 	    // Catch Convert Notify
+ 	    return true;
+ 	}
+     }
+     return false;
+ }
+ 
+ // Kinput event handling
+ boolean Kinput::Handle(Event& ev)
+ {
+     rep->convertedString[0] = '\0';
+ 
+     if ((ev.eventType == ClientEvent) ||
+ 	(ev.rep()->xevent_.type == ClientMessage)) {
+ 	// ClientMessage
+ 	XClientMessageEvent	*cev = &(ev.Rep()->xevent_.xclient);
+ 
+ 	if ((cev->window == rep->window) &&
+ 	    (cev->message_type == rep->convatoms->notify) &&
+ 	    (cev->data.l[0] == rep->convatoms->owner)) {
+ 	    rep->RecieveNotify(ev);
+ 	    return false;
+ 	} else if ((cev->format == 32) &&
+ 		   (cev->message_type == rep->convatoms->end) &&
+ 		   (cev->data.l[0] == rep->convatoms->owner)) {
+ 	    rep->active = false;
+ 	    EndConversion();
+ 	    return false;
+ 	}
+     } else if ((ev.eventType == PropertyEvent) ||
+ 	       (ev.rep()->xevent_.type == PropertyNotify)) {
+ 	// PropertyNotify
+ 	XPropertyEvent	*pev = &(ev.Rep()->xevent_.xproperty);
+ 
+ 	if ((rep->property != None)		&&
+ 	    (pev->window == rep->window)	&&
+ 	    (pev->atom == rep->property)	&&
+ 	    (pev->state == PropertyNewValue)) {
+ 	    return rep->RecieveText(ev);
+ 	}
+     }
+ }
+ 
+ const char* Kinput::GetConvertedString()
+ {
+     if (rep->convertedString[0] == '\0') {
+ 	return NULL;
+     }
+     return rep->convertedString;
+ }
+ 
+ void Kinput::SetConversionSpot(
+   int	spotx,
+   int	spoty
+ ) {
+     rep->SetConversionSpot(spotx, spoty);
+ }
+ 
+ 
+ 
+ KinputRep::KinputRep(XWindow win)
+ {
+     // create kinputRep instance
+     // set instance variable
+     display_ = World::current()->display()->rep()->display_;
+     window  = win;
+ 
+     active = false;
+     
+     if (convatoms == NULL) {
+ 	convatoms = new ConvAtoms(display_);
+     }
+ }
+ 
+ KinputRep::~KinputRep()
+ {
+     if (active == true) {
+ 	// disconnect Kinput
+ 	SendConversionEnd();
+     }
+ }
+ 
+ // Kinput communication method
+ 
+ // Send conversion start request
+ void KinputRep::SendConversionRequest()
+ {
+     XWindow	owner;
+     XEvent	event;
+ 
+     if (active) {
+ 	return;
+     }
+ 
+     // check kinput is active.
+     if ((owner = XGetSelectionOwner(display_, convatoms->owner)) == None) {
+ 	// not found
+ 	active = false;
+ 	return;
+     }
+     
+     convowner = owner;
+     property = None;
+     active = true;
+     
+     isKinput2 = false;
+     if (CheckProtocols()) {
+ 	// Running conversion server is kinput2
+ 	isKinput2 = true;
+ 	SetInputStyle(CONVARG_OVERTHESPOT);
+     }
+ 
+     // request conversion by sending ClientMessage event
+     event.xclient.type = ClientMessage;
+     event.xclient.window = owner;
+     event.xclient.message_type = convatoms->request;
+     event.xclient.format = 32;
+     event.xclient.data.l[0] = convatoms->owner;
+     event.xclient.data.l[1] = window;
+     event.xclient.data.l[2] = convatoms->text;
+     event.xclient.data.l[3] = convatoms->owner;
+     event.xclient.data.l[4] = (isKinput2 ? convatoms->attribute : None);
+     XSendEvent(display_, owner, False, NoEventMask, &event);
+ }
+ 
+ // Send conversion end request
+ void KinputRep::SendConversionEnd()
+ {
+     XEvent	event;
+ 
+     if (!active) {
+ 	return;
+     }
+ 
+     if (convatoms->owner == None) {
+ 	return;
+     }
+ 
+     if (XGetSelectionOwner(display_, convatoms->owner) != convowner) {
+ 	return;
+     }
+ 
+     event.xclient.type		= ClientMessage;
+     event.xclient.window	= convowner;
+     event.xclient.message_type	= convatoms->endRequest;
+     event.xclient.format	= 32;
+     event.xclient.data.l[0]     = convatoms->owner;
+     event.xclient.data.l[1]     = window;
+     XSendEvent(display_, convowner, False, NoEventMask, &event);
+     active = false;
+ }
+ 
+ void KinputRep::RecieveNotify(Event& ev)
+ {
+     if (ev.Rep()->xevent_.xclient.data.l[2] == None) {
+ 	fprintf(stderr, "selection request failed\n");
+ 	active = false;
+ 	return;
+     }
+     
+     property = ev.Rep()->xevent_.xclient.data.l[2];
+     active = true;
+ }
+ 
+ boolean KinputRep::RecieveText(Event&)
+ {
+     Atom		proptype;
+     int			propformat;
+     unsigned long	propsize, rest;
+     unsigned char	*propvalue;
+ 
+     // get conveted string from property
+     XGetWindowProperty(display_, window, property, 0, 100000,
+ 		       True, AnyPropertyType, &proptype, &propformat,
+ 		       &propsize, &rest, &propvalue);
+     
+     if (proptype == None) {
+ 	// property not exist -- but it's not an error
+ 	return false;
+     }
+     
+     convCTtoEUC((unsigned char*)propvalue,
+ 		(int)propsize,
+ 		(unsigned char*)convertedString);
+     return true;
+ }
+ 
+ boolean KinputRep::CheckProtocols(
+ ) {
+     Atom type;
+     int format;
+     unsigned long nitems;
+     unsigned long bytesafter;
+     unsigned long *data, *saveddata;
+     boolean	ret;
+ 
+     data = NULL;
+     if (XGetWindowProperty(display_, convowner, convatoms->profile,
+ 			   0L, 100L, False,
+ 			   convatoms->type,
+ 			   &type, &format, &nitems,
+ 			   &bytesafter, (unsigned char **)&data)) {
+ 	// Conversion Profile not found
+ 	return false;
+     };
+     if ((format != 32) || (type != convatoms->type)) {
+ 	if (data != NULL) {
+ 	    XFree((char *)data);
+ 	};
+ 	return false;
+     }
+ 
+     ret = false;
+     saveddata = data;
+     while (nitems > 0) {
+ 	unsigned long code = CODE_OF_ATTR(*data);
+ 	unsigned long len  = LENGTH_OF_ATTR(*data);
+ 
+ 	data++;
+ 	nitems--;
+ 	if (nitems < len) {
+ 	    break;
+ 	}
+ 
+ 	switch (code) {
+ 	  case CONVPROF_PROTOCOL_VERSION:
+ 	    if (*data == convatoms->version) {
+ 		ret = true;
+ 	    }
+ 	    break;
+ 	  default:
+ 	    break;
+ 	}
+ 	data += len;
+ 	nitems -= len;
+     }
+     XFree((char *)saveddata);
+ 
+     return ret;
+ }
+ 
+ void KinputRep::SetInputStyle(
+   long	style
+ ) {
+     if (!isKinput2) {
+ 	return;
+     }
+ 
+     unsigned long data[2];
+ 
+     data[0] = CONV_ATTR(CONVATTR_INPUT_STYLE, 1);
+     data[1] = style;
+ 
+     XChangeProperty(display_, window, convatoms->attribute,
+ 		    convatoms->attribute, 32,
+ 		    PropModeReplace, (unsigned char *)data, 2);
+ }
+ 
+ void KinputRep::SetConversionSpot(
+   int	spotx,
+   int	spoty
+ ) {
+     if (!isKinput2) {
+ 	return;
+     }
+ 
+     XEvent	event;
+ 
+     event.xclient.type = ClientMessage;
+     event.xclient.window = convowner;
+     event.xclient.message_type = convatoms->attrnotify;
+     event.xclient.format = 32;
+     event.xclient.data.l[0] = convatoms->owner;
+     event.xclient.data.l[1] = window;
+     event.xclient.data.l[2] = CONV_ATTR(CONVATTR_SPOT_LOCATION, 1);
+     event.xclient.data.l[3] = (spotx << 16) | (spoty & 0xffff);
+     XSendEvent(display_, convowner, False, NoEventMask, &event);
+ }
+ 
+ #endif /* JIV */
diff -cNr ivtools-0.6.orig/src/IV-X11/xbitmap.c ivtools-0.6/src/IV-X11/xbitmap.c
*** ivtools-0.6.orig/src/IV-X11/xbitmap.c	Fri Feb 28 08:41:25 1997
--- ivtools-0.6/src/IV-X11/xbitmap.c	Wed Jan 28 20:32:12 1998
***************
*** 122,128 ****
--- 122,140 ----
      rep_ = b;
      int w, h;
      int x, y;
+ #ifndef JIV
      XFontStruct* info = f->rep(d)->font_;
+ #else /* JIV */
+     XFontStruct* info;
+     boolean isEuc;
+     if (f->isComposite() && ((unsigned long)c > 0xff)) {
+ 	info= f->rep2byte(d)->font_;
+ 	isEuc = ((info->min_byte1 > 128) ? true : false);
+     } else {
+ 	info= f->rep(d)->font_;
+     }
+ #endif /* JIV */
+ 
      if (
          c >= info->min_char_or_byte2 && c <= info->max_char_or_byte2 &&
          info->per_char != nil
***************
*** 150,157 ****
--- 162,189 ----
      XSetForeground(dpy, gc, 0);
      XFillRectangle(dpy, map, gc, 0, 0, pw, ph);
      XSetForeground(dpy, gc, 1);
+ #ifndef JIV
      char ch = char(c);
      XDrawString(dpy, map, gc, -x, y, &ch, 1);
+ #else /* JIV */
+     if (f->isComposite() && ((unsigned long)c > 0xff)) {
+ 	const CompositeFont* cmpf = f->getCompositeFont();
+ 	unsigned char s[2];
+ 	s[0] = (unsigned char)((unsigned long)c >> 8);
+ 	s[1] = (unsigned char)((unsigned long)c & 0xff);
+ 	if (!isEuc) {
+ 	    s[0] &= 0x7f;
+ 	    s[1] &= 0x7f;
+ 	}
+ 	XDrawString16(dpy, map, gc, -x, y, (XChar2b*)s, 2);
+ 	if (cmpf->displayBold()) {
+ 	    XDrawString16(dpy, map, gc, -x, y - 1, (XChar2b*)s, 2);
+ 	}
+     } else {
+ 	char ch = char(c);
+ 	XDrawString(dpy, map, gc, -x, y, &ch, 1);
+     }
+ #endif /* JIV */
      if (scale != 1.0) {
          XImage* source = XGetImage(dpy, map, 0, 0, w, h, 0x01, ZPixmap);
          XFreePixmap(dpy, map);
diff -cNr ivtools-0.6.orig/src/IV-X11/xcanvas.c ivtools-0.6/src/IV-X11/xcanvas.c
*** ivtools-0.6.orig/src/IV-X11/xcanvas.c	Fri Feb 28 08:41:25 1997
--- ivtools-0.6/src/IV-X11/xcanvas.c	Wed Jan 28 20:32:12 1998
***************
*** 41,46 ****
--- 41,49 ----
  #include <IV-X11/xdisplay.h>
  #include <IV-X11/xfont.h>
  #include <IV-X11/xraster.h>
+ #ifdef JIV
+ #include <IV-X11/xjivfunc.h>
+ #endif /* JIV */
  #include <OS/math.h>
  #include <OS/list.h>
  #include <OS/table2.h>
***************
*** 652,658 ****
--- 655,665 ----
          tr->width_ += width;
          tr->curx_ = x + width;
          tr->cury_ = y;
+ #ifdef JIV	
+         if (c->text_twobyte_ || ((ch & 0xff00) && f->isComposite())) {
+ #else
          if (c->text_twobyte_) {
+ #endif /* JIV */	    
              *cp++ = char((ch & 0xff00) >> 8);
  	    *cp++ = char(ch & 0xff);
  	} else if (c->text_reencode_) {
***************
*** 1215,1220 ****
--- 1222,1233 ----
                  XDrawString16(
                      dpy, d, gc, t->x0_, t->y0_, (XChar2b*)t->text_, nchars/2
                  );
+ #ifdef JIV
+             } else if (c.font_->isComposite()) {
+ 		JIVDrawString(dpy, d, gc, c.font_, t->x0_, t->y0_,
+ 			      (unsigned char*)t->text_, nchars,
+ 			      display_);
+ #endif /* JIV */
              } else {
                  XDrawString(dpy, d, gc, t->x0_, t->y0_, t->text_, nchars);
              }
***************
*** 1241,1246 ****
--- 1254,1262 ----
                  ++count;
              }
              t->items_[item].nchars = count;
+ #ifdef JIV
+ 	    XSetFont(dpy, gc, c.xfont_->fid);
+ #endif	    
              XDrawText(
                  dpy, d, gc, t->x0_, t->y0_, t->items_, item + 1
              );
